=== debian/control ===
Source: ros-indigo-logger-binding
Section: misc
Priority: extra
Maintainer: Jennifer Buehler <jennifer.e.buehler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-indigo-baselib-binding, ros-indigo-catkin, ros-indigo-roscpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-logger-binding
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-indigo-baselib-binding, ros-indigo-roscpp
Description: Includes libraries and headers to provide loose coupling to logging.
 Provides loggers that use std streams, or ROS logging (if compiled with catkin).
